class Account
  attr_reader :name, :balance
  
  def initialize(n, b)
    @name = n
    @balance = b
  end
  
  def add_interest(rate)
    @balance += @balance * rate / 100
  end

  def display
    printf("%s, you have $%5.2f in your account.\n",
            @name, @balance)
  end
end

my_account = Account.new("Barry", 10.00)
your_account = Account.new("Harriet", 100.00)
their_account = Account.new("Sam & Jen", 7836.00)

an_array = [my_account, your_account, their_account]

puts "ARRAY"
puts "an_array.each ..."
an_array.each { |e| e.display }
puts

a_hash = { :me => my_account, :you => your_account,
           :them => their_account }

puts "HASH"
puts "a_hash.each using |k, v| ..."
a_hash.each { |k, v| v.display }
puts

puts "a_hash.each_value ..."
a_hash.each_value { |v| v.display }
puts

puts "a_hash.each using |e| ..."
a_hash.each { |e| e[1].display }
puts

class Array
  def each_plus_interest(rate)
    for acct in self
      acct.add_interest(rate)
      yield acct
    end
  end
end

puts "ARRAY"
puts "an_array.each_plus_interest ..."
an_array.each_plus_interest(5.0) { |e| e.display }
puts
