class DreamsController < ApplicationController

  def remove_keyword
    @dream = Dream.find(params[:id])
    @dream.keywords.delete(
      Keyword.find(params[:which_keyword]))

    if @dream.save
      flash[:notice] = 'Keyword has been removed.'
    end
    redirect_to :action => 'show', :id => @dream
  end

  def add_keyword
    @dream = Dream.find(params[:id])
    @dream.keywords.push_with_attributes(
      Keyword.find(params[:keyword][:id]))

    if @dream.save
      flash[:notice] = 'Keyword has been added!'
    end
    redirect_to :action => 'show', :id => params[:id]
  end

  def add_some_keywords
    @dream = Dream.find(params[:id])   
    @unused_keywords = 
      Keyword.find(:all) - @dream.keywords

    if @unused_keywords.any? 
      @keywords_to_add = @unused_keywords.select { |key|
        (@params['key'+key.id.to_s]['checked'] == '1')}
      @keywords_to_add.each { |key| 
        @dream.keywords.push_with_attributes(key)}
    end

    if @keywords_to_add.any? and @dream.save
      flash[:notice] = 'Keywords have been added!'
    end
    redirect_to :action => 'show', :id => @dream
  end

  def add_comment
    Dream.find(params[:id]).
      comments.create(params[:comment])
    flash[:notice] = 'Comment was successfully added'
    redirect_to :action => 'show', :id => params[:id]
  end

  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @dream_pages, @dreams = paginate :dreams, :per_page => 10
  end

  def show
    @dream = Dream.find(params[:id])
  end

  def new
    @dream = Dream.new
  end

  def create
    @dream = Dream.new(params[:dream])
    if @dream.save
      flash[:notice] = 'Dream was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @dream = Dream.find(params[:id])
  end

  def update
    @dream = Dream.find(params[:id])
    if @dream.update_attributes(params[:dream])
      flash[:notice] = 'Dream was successfully updated.'
      redirect_to :action => 'show', :id => @dream
    else
      render :action => 'edit'
    end
  end

  def destroy
    Dream.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
